package net.wanji.opt.vo;

import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;
import java.util.Map;

/**
 * @author Kent HAN
 * @date 2023/2/9 8:38
 */
@Data
@NoArgsConstructor
@ApiModel(value = "SceneEvaluateMetricsLaneVO", description = "车道级指标")
public class SceneEvaluateMetricsLaneVO {
    // todo 目前只有拥堵，后期扩展考虑增加字段
    @ApiModelProperty(value = "等级",notes = "0畅通 1轻度 2中度 3严重")
    private Integer level ;

    @ApiModelProperty(value = "车道指标")
    private List<LaneListElement> laneList;

    @NoArgsConstructor
    @Data
    public static class LaneListElement {
        @ApiModelProperty(value = "车道序号")
        private Integer sort;

        @ApiModelProperty(value = "流量（单位：pcu/5min）")
        private Integer flow;

        // 可变指标数据
        @JsonIgnore
        private Map<String, Integer> metricsMap;

        @JsonAnyGetter
        public Map<String, Integer> any() {
            return metricsMap;
        }
    }
}
